Rem --- eWON start section: Cyclic Section
eWON_cyclic_section:
Rem --- eWON user (start)
Rem --- eWON user (end)
End
Rem --- eWON end section: Cyclic Section
Rem --- eWON start section: Init Section
eWON_init_section:
Rem --- eWON user (start)
CLS
SETSYS INF, "LOAD"
SerNum$ = "20192063"
SendTagValues% = 1

//########   CONFIG   ###############
MQTTBrokerURL$ = "mqtt.mclanahan.com"
MQTTPort$ = "8884"
TopicToPublishOn$ = "/topic/flexy/" + SerNum$ + "/data"
TopicToSubscribe$ = "/topic/flexy/" + SerNum$ + "/command"
MsgToPublish$ = "Hello From Flexy " + SerNum$

//Uncomment the below line if you want to send your Tag values in a json format
SendTagValues% = 1

//######## END CONFIG ###############

Last_ConnStatus% = 0
//Configure MQTT Connection parameters

CONNECTMQTT:
MQTT "OPEN", SerNum$ , MQTTBrokerURL$
MQTT "SETPARAM", "PORT", MQTTPort$
MQTT "SETPARAM", "KEEPALIVE", "30"
MQTT "SETPARAM", "CAFILE", "/usr/mqtt/certs/ca.crt"
MQTT "SETPARAM", "CERTFILE", "/usr/mqtt/certs/client.crt"
MQTT "SETPARAM", "KEYFILE", "/usr/mqtt/certs/client.key"
MQTT "SETPARAM", "PROTOCOLVERSION", "3.1.1"
MQTT "SETPARAM", "TLSVERSION", "tlsv1.2"
MQTT "SUBSCRIBE",TopicToSubscribe$,1
//Launch the MQTT process in the background
SETSYS PRG,"RESUMENEXT",1  //Continue in case of error at MQTT "CONNECT"
MQTT "CONNECT"
//If an error is raised --> Log a message
ErrorReturned% = GETSYS PRG,"LSTERR"
IF ErrorReturned% = 28 THEN @Log("[MQTT SCRIPT] WAN interface not yet ready")
SETSYS PRG,"RESUMENEXT",0
//When receiving a message from Broker, "GOTO MQTTRECEIVEMSG"
ONMQTT "GOTO MQTTRECEIVEMSG"  
ONTIMER 1, "GOTO SENDDATA"
TSET 1,10 //publish every 10 seconds
END

SENDDATA:
//Read MQTT Connection Status (5 = Connected, other values = Not connected)
ConnStatus% = MQTT "STATUS"
IF Last_ConnStatus% <> ConnStatus% THEN
  IF ConnStatus% = 5 THEN //Connection is back online
    @Log("[MQTT SCRIPT] Flexy connected to Broker")
  ELSE
    @Log("[MQTT SCRIPT] Flexy disconnected from Broker")
  ENDIF
  Last_ConnStatus% = ConnStatus%
ENDIF
//IF Connected --> Publish messages
IF ConnStatus% = 5 THEN //If connected --> Publish

  IF SendTagValues% = 1 THEN
    NB% = GETSYS PRG,"NBTAGS"
    MsgToPublish$ = "["
    FOR i% = 0 TO NB%-1
      SETSYS Tag, "load",-i%
      TagName$ = GETSYS Tag, "Name"
      TagValue$ = GETSYS Tag, "TagValue"
      IF i% = 0 THEN
        MsgToPublish$ = MsgToPublish$ + '{"tag":"' + TagName$ + '","value":' + TagValue$ + ',"time":"' + @GetTime$() + '"}'
      ELSE  
        MsgToPublish$ = MsgToPublish$ + ',{"tag":"' + TagName$ + '","value":' + TagValue$ + ',"time":"' + @GetTime$() + '"}'
      ENDIF
    NEXT i%
    MsgToPublish$ = MsgToPublish$ + "]"
  ENDIF

  MQTT "PUBLISH",  TopicToPublishOn$ , MsgToPublish$, 0,0
  PRINT "[MQTT SCRIPT] Message '" + MsgToPublish$ + "' sent on topic : " +  TopicToPublishOn$
ELSE //If not connected --> Save message in file
  @Log("[MQTT SCRIPT] Flexy not connected")
ENDIF
END

MQTTRECEIVEMSG:
//Executed when receiving messages from Broker
   MessageQty%=Mqtt "READ"  //Return the number of pending messages
   IF (MessageQty%>0) Then
      MsgTopic$= MQTT "MSGTOPIC"
      MsgData$ = MQTT "MSGDATA"
      @Log("[MQTT SCRIPT] Message '"+ MsgData$ + "' received on topic " +MsgTopic$)
      GOTO MQTTRECEIVEMSG
   ENDIF
END
FUNCTION Log($Msg$)
  LOGEVENT  $Msg$ ,100
  PRINT $Msg$
ENDFN

Function GetTime$()
 $a$ = Time$
 $GetTime$ = $a$(7 To 10) + "-" + $a$(4 To 5) + "-" + $a$(1 To 2) + " " + $a$(12 To 13)+":"+$a$(15 To 16)+":"+$a$(18 To 19)
EndFn

Rem --- eWON user (end)
End
Rem --- eWON end section: Init Section
